<script lang="ts">
import { VueAutosuggest } from 'vue-autosuggest';

import { kebabCase, startCase } from 'lodash';

/* VueAutosuggest documentation -> https://github.com/darrenjennings/vue-autosuggest */
export default {
  name: 'SlpTypeahead',
  components: { VueAutosuggest },
  props: {
    placeholder: {
      type: String,
      required: false,
      default: '',
    },
    options: {
      type: Array,
      required: true,
    },
    sections: {
      type: Array,
      required: false,
      default: undefined,
    },
  },
  data() {
    return {
      query: '',
      sectionConfigs: undefined,
    };
  },
  computed: {
    filteredSuggestions() {
      let filteredSuggestions = [{ data: [] }];

      // Single array suggestions
      if (!this.sections) {
        filteredSuggestions[0].data = this.options.filter((item) =>
          item.name.toLowerCase().includes(this.query.toLowerCase()),
        );
        // Sections suggestions
      } else {
        filteredSuggestions = this.options
          .map((option) => {
            const editedOption = { ...option };
            editedOption.data = option.data
              .filter((item) =>
                item.name.toLowerCase().includes(this.query.toLowerCase()),
              )
              .map((item) => {
                const editedItem = { ...item };
                const regex = new RegExp(`(${this.query})`, 'gi');
                const template =
                  "<span class='slp-typeahead--highlighted'>$1</span>";
                editedItem.highlightedName = editedItem.name.replace(
                  regex,
                  template,
                );
                return editedItem;
              });
            return editedOption;
          })
          .filter((option) => option && option.data.length);
      }

      return filteredSuggestions;
    },
  },
  beforeMount() {
    if (this.sections) {
      this.sectionConfigs = {};
      this.sections.forEach((section) => {
        this.sectionConfigs[section.sectionName] = {
          label: startCase(section.sectionName),
          iconName: section.iconName,
          onSelected: this.onSelect,
          kebabName: kebabCase(section.sectionName),
        };
      });
    }
  },
  methods: {
    onSelect(suggestion: any) {
      this.$emit('select', suggestion.item);
    },
    getSuggestionValue(suggestion: any) {
      return suggestion.item.name;
    },
  },
};
</script>

<template>
  <SlpContainer class="slp-typeahead slp-mb-16">
    <SlpIcon
      class="slp-typeahead__search-icon"
      name="search"
      variant="product"
    />
    <VueAutosuggest
      ref="autosuggest"
      v-model="query"
      :suggestions="filteredSuggestions"
      :input-props="{ id: 'autosuggest__input', placeholder }"
      :section-configs="sectionConfigs"
      :get-suggestion-value="getSuggestionValue"
      @selected="onSelect"
    >
      <template
        v-for="slot in sections"
        #[`before-section-${slot.sectionName}`]="{ section }"
      >
        <div :key="slot.sectionName" class="slp-typeahead__section-header">
          <SlpIcon
            v-if="slot.iconName"
            :name="slot.iconName"
            variant="marketing"
            size="md"
            class="slp-mr-8 slp-typeahead__icon"
          />
          <SlpTypography tag="span" variant="body2-bold">{{
            section.label
          }}</SlpTypography>
        </div>
      </template>
      <template #default="{ suggestion }">
        <SlpTypography tag="span" variant="body2">
          <span v-html="suggestion.item.highlightedName" />
        </SlpTypography>
      </template>
    </VueAutosuggest>
  </SlpContainer>
</template>

<style scoped lang="scss">
.slp-typeahead {
  position: relative;

  &__search-icon {
    position: absolute;
    left: $spacing-16;
    top: 13px;
    color: $color-text-300;
  }

  &__icon {
    width: 24px !important;
    height: 24px !important;
  }

  &:deep &--highlighted {
    font-weight: $font-weight-bold !important;
  }

  &__section-header {
    display: flex;
    align-items: center;
    padding: $spacing-8;
    border-bottom: 1px solid $color-surface-300;
  }

  &:deep #autosuggest__input {
    height: 44px;
    appearance: none;
    width: 100%;
    padding: 18px $spacing-8 $spacing-16 38px;
    border: 1px solid $color-surface-500;
    border-radius: 4px;
    font-size: $text-body-2;

    &::placeholder {
      font-size: $text-body-2;
      color: $color-text-200;
    }

    &:active,
    &:focus,
    &:focus-visible {
      outline: 0;
      box-shadow: 0 2px 4px rgba(0, 0, 0, 0.2);
    }
  }

  &:deep .autosuggest__input--open {
    border-bottom-left-radius: 0 !important;
    border-bottom-right-radius: 0 !important;
  }

  &:deep .autosuggest__results-container {
    position: relative;
    width: 100%;
  }

  &:deep .autosuggest__results {
    max-height: 400px;
    overflow: scroll;
    margin: 0;
    position: absolute;
    width: 100%;
    border: 1px solid $color-surface-500;
    border-bottom-left-radius: 4px;
    border-bottom-right-radius: 4px;
    background: white;
    padding: 0;
    border-top: 0;

    ul {
      list-style: none;
      padding-left: 0;
      margin: 0;
    }

    &-before {
      padding: $spacing-8;
      color: $color-text-link-100;
      border-bottom: 1px solid $color-surface-200;
    }
  }

  &:deep .autosuggest__results-item {
    cursor: pointer;
    padding: $spacing-8 $spacing-8 $spacing-8 $spacing-48;
    transition: all 0.3s ease-in-out;

    &:hover {
      background: $color-surface-200;
    }
  }
}
</style>
